<?php
/**
 * @file
 * Popup für das Anlegen von Sip Einträgen
 */
chdir("..");

include "./includes/variables.php";
include "./misc/database.php";
$ba = new beroAri();
require_once ('./includes/lang.php');
include("./misc/config_parameter.php");

exec("/usr/local/bin/isgw -E", $output, $enumStatus);

$page = $_GET['start'];

$name = '"general"';
$query_comp = $ba->select("SELECT * FROM sip");
while ($entry = $ba->fetch_array($query_comp)) {
    if ($entry['id'] != $_GET['id'])
        $name.=',' . '"' . $entry['name'] . '"';
}
?>


<script type="text/javascript">

    $("#sipp").validate({
        rules: {
            name: {
                required: true,
                specChar: true,
                checkBlank: true,
                compareName: [<?php echo $name; ?>]
            },
            user: "specChar",
            displayname: "specChar",
            auth_user: "specChar",
            secret: "specChar",
            'matchtype[]': {
                required: {
                    depends: function(element) {
                        return $("#profile").val() == "manual";
                    }
                }
            },
            'srtp_crypto_suites[]': {
                required: {
                    depends: function() {
                        return ($("#srtp_mode").val() === "mandatory" || $("#srtp_mode").val() === "optional");
                    }
                }
            },
            sip_from_user_setting_manual: {
                specChar: "#sip_from_user_setting_manual:visible",
            },
            sip_from_display_setting_manual: {
                specChar: "#sip_from_display_setting_manual:visible",
            },
            server_address: {
                checkHostname: true,
                required: true,
                sipPortCheck: "<?php echo udpports(); ?>"
            },
            enum_search_domains: {
                required: true,
            },
            regrefresh: {
                required: "#regrefresh:visible",
                range: [30, 86400]
            }
        }
    });
    $("#stunradio").click(function() {
        $(".options").show();
        $(".stun").show();
        $(".externip").hide();
    });
    $("#externipradio").click(function() {
        $(".options").show();
        $(".externip").show();
        $(".stun").hide();
    });
    $("#nonatradio").click(function() {
        $(".options").hide();
        $(".externip").hide();
        $(".stun").hide();
    });
    $("#manual").click(function() {
        disable_ipMatchtype();
    });
    
    function move(Orig, Dest) {
        var varFromBox = document.getElementById(Orig);
        var varToBox = document.getElementById(Dest);
        if ((varFromBox != null) && (varToBox != null))
        {
            if (varFromBox.length < 1)
            {
                alert('There are no items in the source ListBox');
                return false;
            }
            if (varFromBox.options.selectedIndex == -1) // when no Item is selected the index will be -1

            {
                alert('Please select an Item to move');
                return false;
            }
            while (varFromBox.options.selectedIndex >= 0)
            {
                var newOption = new Option(); // Create a new instance of ListItem

                newOption.text = varFromBox.options[varFromBox.options.selectedIndex].text;
                newOption.value = varFromBox.options[varFromBox.options.selectedIndex].value;
                varToBox.options[varToBox.length] = newOption; //Append the item in Target Listbox

                varFromBox.remove(varFromBox.options.selectedIndex); //Remove the item from Source Listbox

            }
        }
        return false;
    }
    function selectall() {
        selectBox = document.getElementById('sel');
        for (var i = 0; i < selectBox.options.length; i++) {
            selectBox.options[i].selected = true;
        }
    }
    function up() {
        obj = document.getElementById('sel');
        for (var i = 0; i < obj.options.length; i++)
            if (obj.options[ i ].selected) {
                if (i > 0)
                    change(obj, i, i - 1);
            }

    }

    function down() {
        obj = document.getElementById('sel');
        for (var i = obj.options.length - 1; i >= 0; i--) {
            if (obj.options[ i ].selected) {
                if (i < obj.length - 1)
                    change(obj, i, i + 1);
            }
        }
    }
    function change(obj, num1, num2) {
        proVal = obj.options[num1].value;
        proTex = obj.options[num1].text;
        obj.options[num1].value = obj.options[num2].value;
        obj.options[num1].text = obj.options[num2].text;
        obj.options[num2].value = proVal;
        obj.options[num2].text = proTex;
        obj.options[num2].selected = true;
        obj.options[num1].selected = false;
    }
    function hidec() {
        $('#config_sip').hide();


    }

    function srtp() {
        if ($("#srtp_mode").val() == "off") {
            $("#srtp_crypto_suites").prop("disabled", true);
            $("#srtp_crypto_suites_tr").hide();
        } else {
            $("#srtp_crypto_suites_tr").show();
            $("#srtp_crypto_suites").prop("disabled", false);
        }
    }

    function show_config() {
        $('#config_sip').toggle();
    }
    var i = 1;
    function show_advanced() {
        var state = true;
        if (i++ % 2 === 0) {
            $(".advanced").show();
            $(".linkAdvanced").html('<?php echo SIP_SIMPLE_DIS; ?>');
            state = true;
        } else {
            $(".advanced").hide();
            $(".linkAdvanced").html('<?php echo SIP_ADVANCED_DIS; ?>');
            state = false;
        }
        hide_reg(document.getElementById('register').checked, state);
        options(document.getElementById('stunradio').checked, document.getElementById('externipradio').checked, state);
    }
    function hide_reg(value, state) {
        typeof state == 'undefined' ? state = true : state;
        if (value == false) {
            $('#reg').hide();
            $('#reg_option').hide();
        } else if (state === true) {
            $('#reg').show();
            $('#reg_option').show();
        }
    }
    function disable_ipMatchtype(){
        if ($('#manual').prop('checked')==true){
            $('#address').prop('disabled', true);
            $('#address').prop('checked', false);
        }
        if ($('#manual').prop('checked')==false){
            $('#address').prop('disabled', false);
        }
    }
    function hide_server(value) {
        if (value === false) {
            $('.server_address').show();
            $('#server_address').prop('disabled', false);
            $('.enum_search_domains').hide();
            $('#enum_search_domains').prop('disabled', true);
        } else if (value === true) {
            $('.server_address').hide();
            $('#server_address').prop('disabled', true);
            $('.enum_search_domains').show();
            $('#enum_search_domains').prop('disabled', false);
        }
    }
    function options(stun, externip, state) {
        typeof state == 'undefined' ? state = true : state;
        if ((stun == false && externip == false) || state == false) {
            $(".options").hide();
        } else if (state == true) {
            $(".options").show();
        }
        if (stun == true && state == true) {
            $(".stun").show();
            $(".externip").hide();
        } else {
            $(".stun").hide();
        }
        if (externip == true && state == true) {
            $(".externip").show();
            $(".stun").hide();
        } else {
            $(".externip").hide();
        }
    }
    function getProfile() {
        selectedOpt = $("#type").val();
        $("#type option").each(function()
        {
            if (selectedOpt == "manual")
                $("[id='" + $(this).val() + "']").hide();
            else if (selectedOpt == $(this).val())
                $("[id='" + $(this).val() + "']").show();
            else
                $("[id='" + $(this).val() + "']").hide();
        });
    }

    function openPopup(page) {
        profile = $("[id='" + $("#type").val() + "']").val();
        type = $("#type").val();
        popup("start=" + page + "&profile=" + profile + "&type=" + type);
    }
    function change_config(reg) {
        if (reg.checked) {
            document.getElementById("sip_from_user_setting").options[4].selected = true;
            document.getElementById("sip_from_user_setting_manual").style.display = "none";
            document.getElementById("sip_from_display_setting").options[0].selected = true;
            document.getElementById("sip_from_display_setting_manual").style.display = "none";
            document.getElementById("from_sip_src_setting").options[1].selected = true;
        } else {
            document.getElementById("sip_from_user_setting").options[0].selected = true;
            document.getElementById("sip_from_user_setting_manual").style.display = "none";
            document.getElementById("sip_from_display_setting").options[0].selected = true;
            document.getElementById("sip_from_display_setting_manual").style.display = "none";
            document.getElementById("from_sip_src_setting").options[0].selected = true;
        }
    }

</script>

<center>
    <?php
    require_once "./includes/isgwtelnet.php";
    require_once "./includes/profileParser.php";

    /*
     * Die Udpports, die in der Datenbank gespeichert sind werden zurückgegeben
     * und nachher angezeigt.
     */

    function udpports() {
        $ba = new beroAri();
        $query = $ba->select("select udpports from sip_general");
        while ($entry = $ba->fetch_array($query)) {
            return $entry['udpports'];
        }
    }

    function showdefmc($config_values, $fixedSettings) {
        $isgw = new isgwtelnet();
        $result = $isgw->isgw_login();
        if ($result != false) {
            $dialplanc = $isgw->isgw_dialplanconfig();
            $zeilen = split("\n", $dialplanc);
            foreach ($zeilen as $zeile) {
                if (stripos($zeile, '[') === 0) {
                    preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $zeile, $res);
                    if (!in_array($res['name'], $config_values) && ($res['bez'] == "s" || $res['bez'] == "*"))
                        echo "<script>
							var extra_tooltip=document.getElementById('extra_tooltip');
							extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>" . DIALPLAN_OPTION_DIS . "<b>&nbsp;" . $res['name'] . "</b><br>" . DIALPLAN_VALUES_DIS . "<b>&nbsp;&lt;" . $res['val'] . "&gt;</b><br>Default:<b>&nbsp;" . $res['def'] . "</b><br><i>" . htmlspecialchars($res['desc'], ENT_QUOTES) . "</i></p><br>';
						</script>";
                }
            }
            if (!isset($_GET['id'])) {
                $config = $fixedSettings['config'];
            } else {
                $ba = new beroAri();
                $query = $ba->select("select config from sip where id='" . $_GET['id'] . "'");
                while ($entry = $ba->fetch_array($query)) {
                    $config = $entry['config'];
                }
            }
            if ($config != "") {
                $configs = split(',', $config);
                foreach ($configs as $value) {
                    $key = explode('=', $value, 2);
                    if ($key[0] != "" && $key[1] != "" && !in_array($key[0], $config_values)) {
                        echo "<script>$('#addit_options').append('" . $key[0] . "=" . $key[1] . "\\n');
							</script>";
                    } elseif ($key[0] != "" && $key[1] == "" && !in_array($key[0], $config_values)) {
                        echo "<script>$('#addit_options').append('" . $key[0] . "=\\n');
							</script>";
                    }
                }
            }
        }
    }

    function show_confadd($config_values) {
        $isgw = new isgwtelnet();
        $result = $isgw->isgw_login();
        if ($result != false) {
            $dialplanc = $isgw->isgw_dialplanconfig();
            $zeilen = split("\n", $dialplanc);
            foreach ($zeilen as $zeile) {
                if (stripos($zeile, '[') === 0) {
                    preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $zeile, $res);
                    if (!in_array($res['name'], $config_values) && ($res['bez'] == "s" || $res['bez'] == "*"))
                        echo "<script>
							var extra_tooltip=document.getElementById('extra_tooltip');
							extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>" . DIALPLAN_OPTION_DIS . "<b>&nbsp;" . $res['name'] . "</b><br>" . DIALPLAN_VALUES_DIS . "<b>&nbsp;&lt;" . $res['val'] . "&gt;</b><br>Default:<b>&nbsp;" . $res['def'] . "</b><br><i>" . htmlspecialchars($res['desc'], ENT_QUOTES) . "</i></p><br>';
							var addit_options=document.getElementById('addit_options');
							if (addit_options.innerHTML=='')
								addit_options.innerHTML='" . $res['name'] . "=" . $res['def'] . "';
							else
								addit_options.innerHTML=addit_options.innerHTML+'\\n" . $res['name'] . "=" . $res['def'] . "';
						</script>";
                }
            }
        }
    }

    function register($ba, $id, $fixedSettings) {
        $register = getValue($ba, $id, "register", $fixedSettings);
        if ($register == "1")
            $checkbox = "<input type='hidden' name='register' value='0'><input type='checkbox' name='register' id='register' value='1' checked onchange='hide_reg(this.checked); change_config(this)'>";
        else
            $checkbox = "<input type='hidden' name='register' value='0'><input type='checkbox' name='register' id='register' value='1' onchange='hide_reg(this.checked); change_config(this)'>";
        return $checkbox;
    }

    function enum_support($ba, $id, $fixedSettings) {
        $enum_support = getValue($ba, $id, "enum_support", $fixedSettings);
        if ($enum_support == "1")
            $checkbox = "<input type='hidden' name='enum_support' value='0'><input type='checkbox' name='enum_support' id='enum_support' value='1' checked onchange='hide_server(this.checked); '>";
        else
            $checkbox = "<input type='hidden' name='enum_support' value='0'><input type='checkbox' name='enum_support' id='enum_support' value='1' onchange='hide_server(this.checked);'>";
        return $checkbox;
    }

    function register_option($ba, $id, $fixedSettings) {
        $option = getValue($ba, $id, "register_option", $fixedSettings);
        if ($option == "validate")
            return "<option value='validate' selected>validate</option>
			<option value='no-validate no-options-keepalive'>no-validate</option>";
        elseif ($option == "no-validate no-options-keepalive" || $option == "")
            return "<option value='validate'>validate</option>
			<option value='no-validate no-options-keepalive' selected>no-validate</option>";
        else
            return "<option value='validate'>validate</option>
			<option value='no-validate no-options-keepalive' selected>no-validate</option>";
    }

    function sip_transport($option) {
        $sel = "<select name='sip_transport' id='sip_transport'>";
        if ($option == "udp")
            $sel.="<option value='udp' selected>udp</option>";
        else
            $sel.="<option value='udp'>udp</option>";
        if ($option == "tcp")
            $sel.="<option value='tcp' selected>tcp</option>";
        else
            $sel.="<option value='tcp'>tcp</option>";
        if ($option == "tls")
            $sel.="<option value='tls' selected>tls</option>";
        else
            $sel.="<option value='tls'>tls</option>";
        $sel.="</select>";
        return $sel;
    }

    function matchtype($option,$manual) {
        $option = explode("|", $option);
        $checkbox="<fieldset class='alignleft'>";
        (in_array("address", $option) || $option[0]=="") ? $checked = "checked" : $checked = "";
        $checkbox.="<div><input type='checkbox' name='matchtype[]' id='address' value='address' $checked>IP Address</div>";

        (in_array("fromuser", $option)) ? $checked = "checked" : $checked = "";
        $checkbox.="<div><input type='checkbox' name='matchtype[]' value='fromuser' $checked>From User</div>";

        (in_array("touser", $option)) ? $checked = "checked" : $checked = "";
        $checkbox.="<div><input type='checkbox' name='matchtype[]' value='touser' $checked>To User</div>";
        
	(in_array("contactuser", $option)) ? $checked = "checked" : $checked = "";
        $checkbox.="<div><input type='checkbox' name='matchtype[]' value='contactuser' $checked>Contact User</div>";
        
	(in_array("requesturluser", $option)) ? $checked = "checked" : $checked = "";
        $checkbox.="<div><input type='checkbox' name='matchtype[]' value='requesturluser' $checked>Request-URI User</div>";
        
        (in_array("manual", $option)) ? $checked = "checked" : $checked = "";
        $checkbox.="<div><input type='checkbox' name='matchtype[]' id='manual' value='manual' $checked>Manual&nbsp;<input name='matchtype_manual' value='".$manual."' size='11' /></div>";
        $checkbox.="</fieldset>";
        return $checkbox;
    }

    function getValue($ba, $id, $option, $fixedSettings) {
        if ($id === null)
            return $fixedSettings[$option];

        $query = $ba->select("select $option from sip where id=\"$id\"");
        return stripslashes(sqlite_fetch_single($query));
    }

    function profiles() {
        $categories = array();
        $type = "<select name='type' id='type' onChange='getProfile();'>"
                . "<option value='manual'>Manual</option>";
        $dh = @opendir("/usr/conf/profile");
        if (false === $dh) {
            return false;
        }
        while ($file = readdir($dh)) {
            if ("." == $file || ".." == $file)
                continue;
            array_push($categories, $file);
            $type.='<option value=\'' . $file . '\'>' . $file . '</option>';
        }
        $type.="</select>";
        foreach ($categories as $category) {
            $profile .= "<select name='$category' id='$category' style='display:none;'>";
            $dh = @opendir("/usr/conf/profile/" . $category);
            if (false === $dh) {
                return false;
            }
            while ($file = readdir($dh)) {
                if ("." == $file || ".." == $file)
                    continue;
                $profile.='<option value=\'' . $file . '\'>' . $file . '</option>';
            }
            $profile.="</select>";
        }
        return $type . $profile;
    }

    function getProfile() {
        if (isset($_GET['id']))
            return getValue(new beroAri(), $_GET['id'], 'profile', $fixedSettings);
        else if ($_GET['type'] == "manual")
            return $_GET['type'];
        else
            return $_GET['type'] . "-" . $_GET['profile'];
    }

    $config_values = array("t38", "dtmfmode", "codecs", "ie_on_sip", "from_sip_src_setting",
        "wait_for_cancel", "sip_to_user_setting", "sip_from_user_setting",
        "sip_from_display_setting", "failover_proxy", "failover_timeout", "s2i_cpt", "i2s_cpt",
        "sip_national_code", "sip_international_code", "isdn2sip_destination_numformat",
        "dialplan_international_prefix", "sip2dialplan_dad_prefix_setting", "dialplan2sip_oad_prefix_setting",
        "sip2dialplan_oad_prefix_setting", "srtp_mode", "srtp_crypto_suites");




    if (!isset($_GET['id']) && !isset($_GET['profile'])) {
        echo ("<form class='extensions_form' name='profile'>"
        . "<div class='center'>" . SIP_PROFILE_DIS . ": " . profiles() . "</div>"
        . "<div class='clear' />"
        . "<br /><br />"
        . "<div class='center'><input type='button' value='" . BUTTON_NEXT . "' onclick='openPopup(\"" . $page . "\");' /></div>"
        . "</form>");
    } else {


        $fields = array("name", "server_address", "user", "auth_user", "displayname", "secret",
            "sip_transport", "stunserver", "externip", "register", "regrefresh", "register_option",
            "config", "matchtype", "enum_support", "enum_search_domains");
        $fixedSettings = array();

        echo "<script>";
        echo "$( document ).ready(function() {"
        . "hide_reg(document.getElementById('register').checked);"
        . "hide_server($('#enum_support').prop('checked'));"
        . "hidec();"
        . "srtp();"
        . "disable_ipMatchtype();"
        . "$( '#srtp_mode' ).change(function() {"
        . "srtp();"
        . "});"
        . "options($('#stunradio').prop('checked'), $('#externipradio').prop('checked')); ";
        //Profil auslesen
        if (getProfile() != "manual") {
            $profileParser = new profileParser(getProfile());
            $userSettings = $profileParser->getUserSettings();
            $fixedSettings = $profileParser->getFixedSettings();
            //Allgemeiner Hilfetext anzeigen
            if ($profileParser->getHelpText() !== null)
                echo "$('.help').html('<i>" . $profileParser->getHelpText() . "</i>');";
            //Help Text for tooltip überschreiben falls ein Text zur Verfügung in dem Profil steht
            foreach ($userSettings as $value) {
                if ($profileParser->getFieldHelp($value) !== null) {
                    echo "$('." . $value . "').mouseover(function() {
                        Tip('" . $profileParser->getFieldHelp($value) . "');
                    });";
                    echo "$('." . $value . "').mouseout(function() {
                        UnTip();
                    });";
                }
            }
            echo "$('.more').addClass('advanced');";
            //Felder im Formular die nicht user settings sind
            $diffArray = array_diff($fields, $userSettings);
            foreach ($diffArray as $value) {
                if ($value === "stunserver" || $value === 'externip')
                    echo "$('.natoptions').addClass('advanced');";
                echo "$('." . $value . "').addClass('advanced');";
            }
            echo "show_advanced();";
        }
        echo "});";
        echo "</script>";

        (getValue($ba, $_GET['id'], "stunserver", $fixedSettings) == "") ? $stun = "" : $stun = "checked";
        (getValue($ba, $_GET['id'], "externip", $fixedSettings) == "") ? $externip = "" : $externip = "checked";
        (getValue($ba, $_GET['id'], "externip", $fixedSettings) == "" && getValue($ba, $_GET['id'], "stunserver", $fixedSettings) == "") ? $nonat = "checked" : $nonat = "";

        echo ("<form class='extensions_form' name='sipp' id='sipp' action='misc/sip_submit.php' method='POST'>
                        <div class='help'></div>
			<input type=hidden name='start' value='" . $page . "'>
			<input type=hidden name='profile' id='profile' value='" . getProfile() . "'>
			<table border=0 class='contenttoc'>
			<tr class='name' onmouseover=\"Tip('" . TRUNKS_SIP_NAME . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_NAME_DIS . ":</b>&nbsp;</td>
			<td><input name='name' id='name' type='text' value='" . getValue($ba, $_GET['id'], "name", $fixedSettings) . "'></td>
			</tr>
			<tr class='server_address' onmouseover=\"Tip('" . TRUNKS_SIP_SERVER_ADDRESS . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_SERVER_ADDRESS_DIS . ":</b>&nbsp;</td>
			<td><input name='server_address' id='server_address' type='text' value='" . getValue($ba, $_GET['id'], "server_address", $fixedSettings) . "'></td>
			</tr>");
        if ($enumStatus === 0) {
            echo ("<tr class='enum_search_domains' onmouseover=\"Tip('" . TRUNKS_SIP_ENUM_SEARCH_DOMAINS . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_ENUM_SEARCH_DOMAINS_DIS . ":</b>&nbsp;</td>
			<td><input name='enum_search_domains' id='enum_search_domains' type='text' value='" . getValue($ba, $_GET['id'], "enum_search_domain", $fixedSettings) . "'></td>
			</tr>
			<tr class='enum_support' onmouseover=\"Tip('" . TRUNKS_SIP_ENUM_SUPPORT . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_ENUM_SUPPORT_DIS . ":</b>&nbsp;</td>
			<td>" . enum_support($ba, $_GET['id'], $fixedSettings) . "</td>
			</tr>");
        }
        echo ("<tr class='user' onmouseover=\"Tip('" . TRUNKS_SIP_USER . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_USER_DIS . ":</b>&nbsp;</td>
			<td><input name='user' id='user' type='text' value='" . getValue($ba, $_GET['id'], "user", $fixedSettings) . "'></td>
			</tr>
			<tr class='auth_user'>
			<td><b>" . SIP_AUTH_USER_DIS . ":</b>&nbsp;</td>
			<td><input name='auth_user' type='text' value='" . getValue($ba, $_GET['id'], "auth_user", $fixedSettings) . "'></td>
			</tr>
			<tr class='displayname'>
			<td><b>" . SIP_DISPLAYNAME_DIS . ":</b>&nbsp;</td>
			<td><input name='displayname' type='text' value='" . getValue($ba, $_GET['id'], "displayname", $fixedSettings) . "'></td>
			</tr>
			<tr class='secret' onmouseover=\"Tip('" . TRUNKS_SIP_SECRET . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_SECRET_DIS . ":</b>&nbsp;</td>
			<td><input name='secret' id='secret' autocomplete='off' type='password' value='" . getValue($ba, $_GET['id'], "secret", $fixedSettings) . "'></td>
			</tr>
                        <tr class='matchtype'>
			<td><b>" . DIALPLAN_MATCH_TYPE_DIS . ":</b></td>
			<td>" . matchtype(getValue($ba, $_GET['id'], "matchtype", $fixedSettings), getValue($ba, $_GET['id'], "matchtype_manual", $fixedSettings)) . "</td>
			</tr>
                        <tr class='sip_transport'>
			<td><b>" . SIP_GENERAL_SIP_TRANSPORT_DIS . ":</b></td>
			<td>" . sip_transport(getValue($ba, $_GET['id'], "sip_transport", $fixedSettings)) . "</td>
			</tr>
			<tr class='natoptions'>
			<td><b>" . SIP_OPTIONS_DIS . ":</b>&nbsp;</td>
			<td><fieldset class='alignleft'><div><input name='option' id='nonatradio' type='radio' value='nonat' " . $nonat . " >" . SIP_NONAT_DIS . "</div>
                        <div><input name='option' id='stunradio' type='radio' value='stun' " . $stun . " >" . SIP_STUNSERVER_DIS . "</div>
                        <div><input name='option' id='externipradio' type='radio' value='externip' " . $externip . ">" . SIP_EXTERNIP_DIS . "</div></fieldset></td>
			</tr>
			<tr class='options'>
			<td><div class='stun'><b>" . SIP_STUNSERVER_DIS . ":</b>&nbsp;</div> 
                            <div class='externip'><b>" . SIP_EXTERNIP_DIS . ":</b>&nbsp;</div></td>
			<td><div class='stun'><input name='stunserver' id='stunserver' type='text' value='" . getValue($ba, $_GET['id'], "stunserver", $fixedSettings) . "' ></div>
                            <div class='externip'><input name='externip' id='externip' type='text' value='" . getValue($ba, $_GET['id'], "externip", $fixedSettings) . "'></div></td>
			</tr>
			<tr class='register' onmouseover=\"Tip('" . TRUNKS_SIP_REGISTER . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_REGISTER_DIS . ":</b>&nbsp;</td>
			<td>" . register($ba, $_GET['id'], $fixedSettings) . "</td>
			</tr>
			<tr id='reg' class='regrefresh' onmouseover=\"Tip('" . TRUNKS_SIP_REGREFRESH . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_REGISTRATION_INTERVALL_DIS . ":</b></td>");
        if (getValue($ba, $_GET['id'], "regrefresh", $fixedSettings) == "")
            $regrefresh = "300";
        else
            $regrefresh = getValue($ba, $_GET['id'], "regrefresh", $fixedSettings);
        echo ("<td><input name='regrefresh' id='regrefresh' type='text' value='" . $regrefresh . "'></td>
			</tr>
			<tr id='reg_option' class='register_option' onmouseover=\"Tip('" . TRUNKS_SIP_REGISTER_OPTION . "')\" onmouseout='UnTip()'>
			<td><b>" . SIP_REGISTER_OPTION_DIS . ":</b></td>
			<td>
			<select name='register_option' onmouseover=\"Tip('" . TRUNKS_SIP_REGISTER_OPTION . "')\" onmouseout='UnTip()'>" . register_option($ba, $_GET['id'], $fixedSettings) . "</select></td>
			</tr>
			<tr>
			<td align='center' colspan='2'>");
        if (getProfile() != "manual")
            echo ("<a href='#' onclick='show_advanced();' class='linkAdvanced'>" . SIP_ADVANCED_DIS . "</a>&nbsp;&nbsp;");
            $config = getValue($ba, $_GET['id'], 'config', $fixedSettings);
        echo ("<a href='#' onclick='show_config();' class='more'>" . SIP_MORE_DIS . "...</a></td>
			</tr>
			</table>
			<br/>
                                <table id='config_sip' class='contenttoc'>
					<tr><td colspan='2' align='center'><b>" . DIALPLAN_CONFIGURATION_DIS . "</b></td></tr>
					<tr onmouseover=\"Tip('" . T38 . "')\" onmouseout='UnTip()' id='t38_tr'>
						<td><b>" . DIALPLAN_T38_SUPPORT_DIS . "</b></td>
		    			<td>" . t38($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . DTMFMODE . "')\" onmouseout='UnTip()' id='dtmf_tr'>
						<td><b>" . DIALPLAN_DTMF_MODE_DIS . "</b></td>
		    			<td>" . dtmfmode($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . IE_ON_SIP . "')\" onmouseout='UnTip()' id='ie_on_sip_tr'>
						<td><b>" . DIALPLAN_IE_ON_SIP_DIS . "</b></td>
		    			<td>" . ie_on_sip($config) . "</td>
					</tr>
					<tr id='codecs_tr'>
						<td><b>" . DIALPLAN_CODECS_DIS . "</b></td>
		    			<td>" . codecs($config) . "</td>
   		    		</tr>
					<tr onmouseover=\"Tip('" . WAIT_FOR_CANCEL . "')\" onmouseout='UnTip()' id='wait_for_cancel_tr'>
						<td><b>" . DIALPLAN_WAIT_FOR_CANCEL_DIS . "</b></td>
		    			<td>" . wait_for_cancel($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . CALL_PROGRESS_TABLE . "')\" onmouseout='UnTip()' id='s2i_cpt_tr'>
						<td><b>" . DIALPLAN_CALL_PROGRESS_TABLE_S2I_DIS . "</b></td>
		    			<td>" . s2i_cpt($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . CALL_PROGRESS_TABLE . "')\" onmouseout='UnTip()' id='s2i_cpt_tr'>
						<td><b>" . DIALPLAN_CALL_PROGRESS_TABLE_I2S_DIS . "</b></td>
		    			<td>" . i2s_cpt($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . FAILOVER_ACCOUNT . "')\" onmouseout='UnTip()' id='failover_proxy_tr'>
						<td><b>" . DIALPLAN_FAILOVER_ACCOUNT_DIS . "</b></td>
						<td>" . failover_proxy($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . FAILOVER_TIMEOUT . "')\" onmouseout='UnTip()' id='failover_timeout_tr'>
						<td><b>" . DIALPLAN_FAILOVER_TIMEOUT_DIS . "</b></td>
						<td>" . failover_timeout($config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . FROM_SIP_SRC_SETTING . "')\" onmouseout='UnTip()' id='sip_src_setting_tr'>
						<td><b>" . DIALPLAN_FROM_SIP_SRC_SETTING_DIS . "</b></td>
						<td>" . from_sip_src_setting($config) . "</td>
					</tr>
					<tr>
						<td colspan='2'>&nbsp;</td>
					</tr>
                                        <tr>
						<th colspan='2'>" . DIALPLAN_CALLED_PARTY_NUMBER_DIS . "</th>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_TO_USER_SETTING . "')\" onmouseout='UnTip()' id='sip_from_user_setting_tr'>
						<td><b>" . DIALPLAN_SIP_TO_USER_SETTING_DIS . "</b></td>
						<td>" . called_party_number_sip('sip_to_user_setting', $config) . "</td>
					</tr>
					<tr>
						<th colspan='2'>" . DIALPLAN_CALLER_ID_MAPPING_DIS . "</th>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_FROM_USER_SETTING . "')\" onmouseout='UnTip()' id='sip_from_user_setting_tr'>
						<td><b>" . DIALPLAN_SIP_FROM_USER_SETTING_DIS . "</b></td>
						<td>" . caller_id_mapping_sip('sip_from_user_setting', $config) . "</td>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_FROM_DISPLAY_SETTING . "')\" onmouseout='UnTip()' id='sip_from_display_setting_tr'>
						<td><b>" . DIALPLAN_SIP_FROM_DISPLAY_SETTING_DIS . "</b></td>
						<td>" . caller_id_mapping_sip('sip_from_display_setting', $config) . "</td>
					</tr>
                                        <tr>
						<td colspan='2'>&nbsp;</td>
					</tr>
                                        <tr>
						<th colspan='2'>" . DIALPLAN_PROVIDER_INTERNATIONAL_NUMBER_FORMAT_DIS . "</th>
					</tr>
                                        <tr onmouseover=\"Tip('" . SIP_NATIONAL_CODE_SETTING . "')\" onmouseout='UnTip()' id='sip_national_code_tr'>
						<td><b>" . DIALPLAN_SIP_NATIONAL_CODE_DIS . "</b></td>
						<td>" . sip_input_text('sip_national_code', $config) . "</td>
					</tr>
                                        <tr onmouseover=\"Tip('" . SIP_INTERNATIONAL_CODE_SETTING . "')\" onmouseout='UnTip()' id='sip_international_code_tr'>
						<td><b>" . DIALPLAN_SIP_INTERNATIONAL_CODE_DIS . "</b></td>
						<td>" . sip_input_text('sip_international_code', $config) . "</td>
					</tr>
                                        <tr id='dialplan_international_prefix_tr'>
						<td><b>" . DIALPLAN_DIALPLAN_INTERNATIONAL_PREFIX_DIS . "</b></td>
						<td>" . sip_input_text('dialplan_international_prefix', $config, "00") . "</td>
					</tr>
                                        <tr>
						<td colspan='2'>" . DIALPLAN_PSTN_TO_SIP_DIS . "</td>
					</tr>
                                        <tr onmouseover=\"Tip('" . ISDN2SIP_DESTINATION_NUMFORMAT . "')\" onmouseout='UnTip()' id='isdn2sip_destination_numformat_tr'>
						<td><b>" . DIALPLAN_ISDN2SIP_DESTINATION_NUMFORMAT_DIS . "</b></td>
						<td>" . isdn2sip_destination_numformat($config) . "</td>
					</tr>
                                        <tr id='sip2dialplan_dad_prefix_setting_tr'>
						<td><b>" . DIALPLAN_DIALPLAN2SIP_OAD_PREFIX_SETTING_DIS . "</b></td>
						<td>" . dialplan2sip_oad_prefix_setting($config) . "</td>
					</tr>
                                        <tr>
						<td colspan='2'>" . DIALPLAN_SIP_TO_PSTN_DIS . "</td>
					</tr>
                                        <tr id='sip2dialplan_dad_prefix_setting_tr'>
						<td><b>" . DIALPLAN_SIP2DIALPLAN_DAD_PREFIX_SETTING_DIS . "</b></td>
						<td>" . sip2dialplan_dad_prefix_setting($config) . "</td>
					</tr>
                                        <tr id='sip2dialplan_oad_prefix_setting_tr'>
						<td><b>" . DIALPLAN_SIP2DIALPLAN_OAD_PREFIX_SETTING_DIS . "</b></td>
						<td>" . sip2dialplan_oad_prefix_setting($config) . "</td>
					</tr>
                                        <tr>
						<th colspan='2'>SRTP</th>
					</tr>
                                        <tr id='srtp_mode_tr' onmouseover=\"Tip('" . SRTP_MODE . "')\" onmouseout='UnTip()'>
						<td><b>" . DIALPLAN_SRTP_MODE_DIS . "</b></td>
						<td>" . srtp_mode($config) . "</td>
					</tr>
                                        <tr id='srtp_crypto_suites_tr'>
						<td><b>" . DIALPLAN_SRTP_CRYPTO_SUITES_DIS . "</b></td>
						<td>" . srtp_crypto_suites($config) . "</td>
					</tr>
					<tr>
						<td colspan='2'>&nbsp;</td>
					</tr>
					<tr onmouseover=\"Tip('" . ADDIT_OPTIONS . "')\" onmouseout='UnTip()'>
						<td colspan='2'><b>" . DIALPLAN_ADDITIONAL_CONFIG_DIS . "</b></td>
					</tr>
					<tr onmouseover=\"Tip('" . ADDIT_OPTIONS . "')\" onmouseout='UnTip()'>
						<td colspan='2'><textarea name='addit_options' id='addit_options' rows='4' style='width:305px;'></textarea></td>
					</tr>
					<tr>
						<td colspan='2'>
						<br>
						<b>" . DIALPLAN_ADDITIONAL_CONFIG_DOC_DIS . "</b>
						</td>
					</tr>
					<tr>
						<td colspan='2'>
						<p id='extra_tooltip' style='text-align:left; height: 150px; width:305px; overflow: auto; border: 1px solid #A31D26; background: none repeat scroll 0% 0% rgb(238, 238, 238); color: rgb(0, 0, 0);'>
						</td>
					</tr>
					</table><br>");
        if (isset($_GET['id']) || getProfile() != "manual") {
            showdefmc($config_values, $fixedSettings);
        } else {
            show_confadd($config_values);
        }
        if (isset($_GET['id']))
            echo ("<input type='hidden' name='alt_name' value='" . getValue($ba, $_GET['id'], "name", $fixedSettings) . "'><input type='hidden' name='id_upd' value='" . $_GET['id'] . "'>");
        echo ("<div class='center'><input name='submit' type='submit' value='" . BUTTON_SAVE . "' onclick='selectall();' onmouseover=\"Tip('" . TRUNKS_SIP_SAVE . "')\" onmouseout='UnTip()'>
			 &nbsp;&nbsp;<input name='close' type='button' value='" . BUTTON_CLOSE . "' onclick='javascript:$(\"#dialog\").dialog(\"close\");' onmouseover=\"Tip('" . POPUPS_BUTTON_CLOSE . "')\" onmouseout='UnTip()'></div>
			</form>");
    }
    ?>
</center>

